<template>
  <div class="app-container-MACHINE">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label=this.wsglName prop="macharea">
        <el-input
          v-model="queryParams.macharea"
          :placeholder="$t('请输入') + 'MACHINE/AREA'"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item :label="$t('负责人')" prop="owner">
        <el-input
          v-model="queryParams.owner"
          :placeholder="$t('请输入') + $t('负责人')"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item :label="$t('年份')" prop="year">
        <el-input
          v-model="queryParams.year"
          :placeholder="$t('请输入') + $t('年份')"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item :label="$t('班值')" prop="teams">
        <el-select v-model="teams" :placeholder="$t('请选择') + $t('班值')" clearable size="small" multiple>
          <el-option
            v-for="dict in teamOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">{{ $t('搜索') }}</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">{{ $t('重置') }}</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['production:wsgl:add']"
        >{{ $t('新增') }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['production:wsgl:edit']"
        >{{ $t('修改') }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['production:wsgl:remove']"
        >{{ $t('删除') }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="info"
          icon="el-icon-upload2"
          size="mini"
          @click="handleImport"
          v-hasPermi="['production:wsgl:edit']"
        >{{ $t('导入') }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['production:wsgl:export']"
        >{{ $t('导出') }}</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="wsglList" @selection-change="handleSelectionChange" :cell-class-name="tableCellClassName" @sort-change="sortChange" :height="clientHeight" border>
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column :label="$t('年份')" align="center" prop="year" :show-overflow-tooltip="true"/>
      <el-table-column :label=this.wsglName align="center" prop="macharea" width="250" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('5S编号')" align="center" prop="wsno" width="120" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('负责人')" align="center" prop="owner" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('一月')" align="center" prop="jan" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('二月')" align="center" prop="feb" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('三月')" align="center" prop="mar" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('四月')" align="center" prop="apr" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('五月')" align="center" prop="may" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('六月')" align="center" prop="jun" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('七月')" align="center" prop="jul" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('八月')" align="center" prop="aug" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('九月')" align="center" prop="sep" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('十月')" align="center" prop="oct" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('十一月')" align="center" prop="nov" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('十二月')" align="center" prop="dec" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('排名')" align="center" prop="average" :show-overflow-tooltip="true" sortable="custom"/>
      <el-table-column :label="$t('班值')" align="center" prop="team" :formatter="teamFormat" />
      <el-table-column :label="$t('所属部门')" align="center" prop="deptName" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('备注')" align="center" prop="remarks" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('操作')" align="center" fixed="right" width="120" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['production:wsgl:edit']"
          >{{ $t('修改') }}</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['production:wsgl:remove']"
          >{{ $t('删除') }}</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改5S管理对话框 -->
    <el-dialog  :close-on-click-modal="false" v-dialogDrag :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item :label=this.wsglName prop="macharea">
          <el-input v-model="form.macharea" :placeholder="$t('请输入') + 'MACHINE/AREA'" />
        </el-form-item>
        <el-form-item :label="$t('5S编号')" prop="wsno">
          <el-input v-model="form.wsno" :placeholder="$t('请输入') + $t('5S编号')" />
        </el-form-item>
        <el-form-item :label="$t('负责人')" prop="owner">
          <el-input v-model="form.owner" :placeholder="$t('请输入') + $t('负责人')" />
        </el-form-item>
        <el-form-item :label="$t('年份')" prop="year">
          <el-input v-model="form.year" :placeholder="$t('请输入') + $t('年份')" onkeyup="value=value.replace(/[^\d]/g,'')"/>
        </el-form-item>
        <el-form-item :label="$t('一月')" prop="jan">
          <el-input v-model="form.jan" :placeholder="$t('请输入') + $t('一月')" onkeyup="value=value.replace(/[^\d]/g,'')"/>
        </el-form-item>
        <el-form-item :label="$t('二月')" prop="feb">
          <el-input v-model="form.feb" :placeholder="$t('请输入') + $t('二月')" onkeyup="value=value.replace(/[^\d]/g,'')"/>
        </el-form-item>
        <el-form-item :label="$t('三月')" prop="mar">
          <el-input v-model="form.mar" :placeholder="$t('请输入') + $t('三月')" onkeyup="value=value.replace(/[^\d]/g,'')"/>
        </el-form-item>
        <el-form-item :label="$t('四月')" prop="apr">
          <el-input v-model="form.apr" :placeholder="$t('请输入') + $t('四月')" onkeyup="value=value.replace(/[^\d]/g,'')"/>
        </el-form-item>
        <el-form-item :label="$t('五月')" prop="may">
          <el-input v-model="form.may" :placeholder="$t('请输入') + $t('五月')" onkeyup="value=value.replace(/[^\d]/g,'')"/>
        </el-form-item>
        <el-form-item :label="$t('六月')" prop="jun">
          <el-input v-model="form.jun" :placeholder="$t('请输入') + $t('六月')" onkeyup="value=value.replace(/[^\d]/g,'')"/>
        </el-form-item>
        <el-form-item :label="$t('七月')" prop="jul">
          <el-input v-model="form.jul" :placeholder="$t('请输入') + $t('七月')" onkeyup="value=value.replace(/[^\d]/g,'')"/>
        </el-form-item>
        <el-form-item :label="$t('八月')" prop="aug">
          <el-input v-model="form.aug" :placeholder="$t('请输入') + $t('八月')" onkeyup="value=value.replace(/[^\d]/g,'')"/>
        </el-form-item>
        <el-form-item :label="$t('九月')" prop="sep">
          <el-input v-model="form.sep" :placeholder="$t('请输入') + $t('九月')" onkeyup="value=value.replace(/[^\d]/g,'')"/>
        </el-form-item>
        <el-form-item :label="$t('十月')" prop="oct">
          <el-input v-model="form.oct" :placeholder="$t('请输入') + $t('十月')" onkeyup="value=value.replace(/[^\d]/g,'')"/>
        </el-form-item>
        <el-form-item :label="$t('十一月')" prop="nov">
          <el-input v-model="form.nov" :placeholder="$t('请输入') + $t('十一月')" onkeyup="value=value.replace(/[^\d]/g,'')"/>
        </el-form-item>
        <el-form-item :label="$t('十二月')" prop="dec">
          <el-input v-model="form.dec" :placeholder="$t('请输入') + $t('十二月')" onkeyup="value=value.replace(/[^\d]/g,'')"/>
        </el-form-item>
        <el-form-item :label="$t('备注')" prop="remarks">
          <el-input v-model="form.remarks" :placeholder="$t('请输入') + $t('备注')" />
        </el-form-item>
        <el-form-item :label="$t('班值')" prop="team">
          <el-select v-model="form.team" :placeholder="$t('请选择') + $t('班值')">
            <el-option
              v-for="dict in teamOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('归属部门')" prop="deptId">
          <treeselect v-model="form.deptId" :options="deptOptions" :show-count="true" :placeholder="$t('请选择') + $t('归属部门')" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">{{ $t('确 定') }}</el-button>
        <el-button @click="cancel">{{ $t('取 消') }}</el-button>
      </div>
    </el-dialog>

    <!-- 用户导入对话框 -->
    <el-dialog  :close-on-click-modal="false" v-dialogDrag :title="upload.title" :visible.sync="upload.open" width="400px" append-to-body>
      <el-upload
        ref="upload"
        :limit="1"
        accept=".xlsx, .xls"
        :headers="upload.headers"
        :action="upload.url"
        :disabled="upload.isUploading"
        :on-progress="handleFileUploadProgress"
        :on-success="handleFileSuccess"
        :auto-upload="false"
        drag
      >
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">
          {{ $t('将文件拖到此处，或') }}
          <em>{{ $t('点击上传') }}</em>
        </div>
        <div class="el-upload__tip" slot="tip">
          <!--<el-checkbox v-model="upload.updateSupport" />是否更新已经存在的用户数据-->
          <el-link type="info" style="font-size:12px" @click="importTemplate">{{ $t('下载模板') }}</el-link>
        </div>
        <form ref="downloadFileForm" :action="upload.downloadAction" target="FORMSUBMIT">
          <input name="type" :value="upload.type" hidden />
        </form>
        <div class="el-upload__tip" style="color:#ff0000" slot="tip">{{ $t('提示：仅允许导入“xls”或“xlsx”格式文件！') }}</div>
      </el-upload>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFileForm">{{ $t('确 定') }}</el-button>
        <el-button @click="upload.open = false">{{ $t('取 消') }}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
  import {addWsgl, delWsgl, exportWsgl, getWsgl, listWsgl, updateWsgl} from "@/api/production/wsgl";
  import {treeselect} from "@/api/system/dept";
  import {getToken} from "@/utils/auth";
  import Treeselect from "@riophae/vue-treeselect";
  import "@riophae/vue-treeselect/dist/vue-treeselect.css";

  export default {
    name: "wsglMACHINE",
    components: { Treeselect },
    props: ['item', 'name'],
    data() {
      return {
        // 遮罩层
        loading: true,
        // 选中数组
        ids: [],
        // 非单个禁用
        single: true,
        // 非多个禁用
        multiple: true,
        // 显示搜索条件
        showSearch: false,
        // 总条数
        total: 0,
        // 5S管理表格数据
        wsglList: [],
        // 班值字典
        teamOptions: [],
        // 弹出层标题
        title: "",
        // 部门树选项
        deptOptions: undefined,
        clientHeight:300,
        // 是否显示弹出层
        open: false,
        //机器/区域
        wsglName: this.name,
        // 用户导入参数
        upload: {
          //下载模板请求地址
          downloadAction: process.env.VUE_APP_BASE_API + '/common/template',
          //下载模板类型
          type: this.name,
          // 是否显示弹出层（用户导入）
          open: false,
          // 弹出层标题（用户导入）
          title: "",
          // 是否禁用上传
          isUploading: false,
          // 是否更新已经存在的用户数据
          updateSupport: 0,
          // 设置上传的请求头部
          headers: { Authorization: "Bearer " + getToken() },
          // 上传的地址
          url: process.env.VUE_APP_BASE_API + "/production/wsgl/importData"
        },
        // 查询参数
        queryParams: {
          pageNum: 1,
          pageSize: 20,
          macharea: null,
          wsno: null,
          owner: null,
          year: null,
          jan: null,
          feb: null,
          mar: null,
          apr: null,
          may: null,
          jun: null,
          jul: null,
          aug: null,
          sep: null,
          oct: null,
          nov: null,
          dec: null,
          average: null,
          item: this.item,
          delFlag: 0,
          createrCode: null,
          createdate: null,
          updaterCode: null,
          updatedate: null,
          deptId: null,
          remarks: null,
          teams: null,
          order: null
        },
        teams: [],
        // 表单参数
        form: {},
        // 表单校验
        rules: {
          macharea: [
            { required: true, message: "MACHINE/AREAa" + this.$t('不能为空'), trigger: "blur" }
          ],
          wsno: [
            { required: true, message: this.$t('编号') + this.$t('不能为空'), trigger: "blur" }
          ],
          deptId: [
            { required: true, message: this.$t('部门编号') + this.$t('不能为空'), trigger: "blur" }
          ],
        }
      };
    },
    watch: {
      // 根据名称筛选部门树
      deptName(val) {
        this.$refs.tree.filter(val);
      }
    },
    created() {
      //设置表格高度对应屏幕高度
      this.$nextTick(() => {
        this.clientHeight = (document.body.clientHeight - 80) * 0.8
      })
      this.getList();
      this.getTreeselect();
      this.getDicts("ACCIDENT_TEAM").then(response => {
        this.teamOptions = response.data;
      });
    },
    methods: {
      /** 查询5S管理列表 */
      getList() {
        this.loading = true;
        this.queryParams.teams = this.teams.join()
        listWsgl(this.queryParams).then(response => {
          this.wsglList = response.rows;
          this.total = response.total;
          this.loading = false;
        });
      },
      //排序
      sortChange(val){
        if (val.order === 'descending') {
          this.queryParams.order = 'desc'
        } else {
          this.queryParams.order = 'asc'
        }
        this.getList()
      },
      //根据分数显示颜色提示
      tableCellClassName({ row, column, rowIndex, columnIndex }) {
        if (columnIndex == 5){
          return this.changeColor(row.jan)
        }
        if (columnIndex == 6){
          return this.changeColor(row.feb)
        }
        if (columnIndex == 7){
          return this.changeColor(row.mar)
        }
        if (columnIndex == 8){
          return this.changeColor(row.apr)
        }
        if (columnIndex == 9){
          return this.changeColor(row.may)
        }
        if (columnIndex == 10){
          return this.changeColor(row.jun)
        }
        if (columnIndex == 11){
          return this.changeColor(row.jul)
        }
        if (columnIndex == 12){
          return this.changeColor(row.aug)
        }
        if (columnIndex == 13){
          return this.changeColor(row.sep)
        }
        if (columnIndex == 14){
          return this.changeColor(row.oct)
        }
        if (columnIndex == 15){
          return this.changeColor(row.nov)
        }
        if (columnIndex == 16){
          return this.changeColor(row.dec)
        }
        if (columnIndex == 17){
          return this.changeColor(row.average)
        }
      },
      changeColor (value) {
        if(value >= 90){
          return 'cell90'
        }else if( value >= 75 && value < 90) {
          return 'cell75'
        }else if( value >= 60 && value < 75) {
          return 'cell60'
        }else if( value >= 30 && value < 60) {
          return 'cell30'
        }else if( value >= 1 && value < 30) {
          return 'cell0'
        }
      },
      /** 查询部门下拉树结构 */
      getTreeselect() {
        treeselect().then(response => {
          this.deptOptions = response.data;
        });
      },
      // 班值字典翻译
      teamFormat(row, column) {
        return this.selectDictLabel(this.teamOptions, row.team);
      },
      // 取消按钮
      cancel() {
        this.open = false;
        this.reset();
      },
      // 表单重置
      reset() {
        this.form = {
          id: null,
          macharea: null,
          wsno: null,
          owner: null,
          year: null,
          jan: null,
          feb: null,
          mar: null,
          apr: null,
          may: null,
          jun: null,
          jul: null,
          aug: null,
          sep: null,
          oct: null,
          nov: null,
          dec: null,
          average: null,
          item: this.item,
          delFlag: null,
          createrCode: null,
          createdate: null,
          updaterCode: null,
          updatedate: null,
          deptId: null,
          remarks: null,
          team: null
        };
        this.resetForm("form");
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.resetForm("queryForm");
        this.teams = []
        this.handleQuery();
      },
      // 多选框选中数据
      handleSelectionChange(selection) {
        this.ids = selection.map(item => item.id)
        this.single = selection.length!==1
        this.multiple = !selection.length
      },
      /** 新增按钮操作 */
      handleAdd() {
        this.reset();
        this.open = true;
        this.title = this.$t('新增') + " " + this.$t('5S管理');
      },
      /** 修改按钮操作 */
      handleUpdate(row) {
        this.reset();
        const id = row.id || this.ids
        getWsgl(id).then(response => {
          this.form = response.data;
          this.open = true;
          this.title = this.$t('修改')+ this.$t('5S管理');
        });
      },
      /** 提交按钮 */
      submitForm() {
        this.$refs["form"].validate(valid => {
          if (valid) {
            if (this.form.id != null) {
              updateWsgl(this.form).then(response => {
                this.msgSuccess(this.$t('修改成功'));
                this.open = false;
                this.getList();
              });
            } else {
              addWsgl(this.form).then(response => {
                this.msgSuccess(this.$t('新增成功'));
                this.open = false;
                this.getList();
              });
            }
          }
        });
      },
      /** 删除按钮操作 */
      handleDelete(row) {
        const ids = row.id || this.ids;
        this.$confirm(this.$t('是否确认删除5S管理编号为"') + ids + this.$t('"的数据项?'), this.$t('警告'), {
          confirmButtonText: this.$t('确定'),
          cancelButtonText: this.$t('取消'),
          type: "warning"
        }).then(function() {
          return delWsgl(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess(this.$t('删除成功'));
        })
      },
      /** 导出按钮操作 */
      handleExport() {
        const queryParams = this.queryParams;
        this.$confirm(this.$t('是否确认导出所有5S管理数据项?'), this.$t('警告'), {
          confirmButtonText: this.$t('确定'),
          cancelButtonText: this.$t('取消'),
          type: "warning"
        }).then(function() {
          return exportWsgl(queryParams);
        }).then(response => {
          this.download(response.msg);
        })
      },
      /** 导入按钮操作 */
      handleImport() {
        this.upload.title = this.$t('用户导入');
        this.upload.open = true;
      },
      /** 下载模板操作 */
      importTemplate() {
        this.$refs['downloadFileForm'].submit()
      },
      // 文件上传中处理
      handleFileUploadProgress(event, file, fileList) {
        this.upload.isUploading = true;
      },
      // 文件上传成功处理
      handleFileSuccess(response, file, fileList) {
        this.upload.open = false;
        this.upload.isUploading = false;
        this.$refs.upload.clearFiles();
        if (response.data[0] != null) {
          this.$alert(this.$t('成功导入') + response.msg + this.$t('条数据') + "，" + this.$t('第') + response.data + this.$t('行数据出现错误导入失败')+"。", this.$t('导入结果'), { dangerouslyUseHTMLString: true });
        }else {
          this.$alert(this.$t('成功导入') + response.msg + this.$t('条数据'), this.$t('导入结果'), { dangerouslyUseHTMLString: true });
        }
        this.getList();
      },
      // 提交上传文件
      submitFileForm() {
        this.$refs.upload.submit();
      }
    }
  }
</script>
